import { createSlice } from '@reduxjs/toolkit'

export const recorderSlice = createSlice({
    name: 'recorder',
    initialState: {
        list: [],
        currentIndex: 0,
        currentLyric: [],
        currentBlob: {},
        currentWaveData: [],
        currentTime: 0, // 当前音频播放时间
        pause: true,
    },
    reducers: {
        setList: (state, action) => {
            state.list = action.payload;
        },
        setCurrentIndex: (state, action) => {
            state.pause = true;
            state.currentIndex = action.payload;
        },
        setCurrentLyric: (state, action) => {
            state.currentLyric = action.payload;
        },
        setCurrentBlob: (state, action) => {
            state.currentBlob = action.payload;
        },
        setCurrentTime: (state, action) => {
            state.currentTime = action.payload;
        },
        setCurrentWaveData: (state, action) => {
            state.currentWaveData = action.payload;
        },
        togglePauseState: (state) => {
            state.pause = !state.pause;
        },
    }
})

// Action creators are generated for each case reducer function
export const { setCurrentIndex, setList, setCurrentLyric, setCurrentBlob, togglePauseState, setCurrentTime, setCurrentWaveData } = recorderSlice.actions

export default recorderSlice.reducer