import { createSlice } from '@reduxjs/toolkit'

export const userSlice = createSlice({
    name: 'user',
    initialState: {
        flushToken: "",
        accessToken: "",
        passportId: 0,
        createTime: "",
        userName: "",
        nickName: "",
        avatarUrl: "",
        agreeAgreement: true,
        account: "13682423271",
        password: "yzs123456",
        verificationCode: "",
    },
    reducers: {
        setFlushToken: (state, token) => {
            state.flushToken = token.payload;
        },
        setAccessToken: (state, token) => {
            state.accessToken = token.payload;
        },
        setUserInfo: (state, action) => {
            state.passportId = action.payload.passportId
            state.createTime = action.payload.createTime
            state.userName = action.payload.userName
        },
        setSelectInfo: (state, action) => {
            state.nickName = action.payload.nickName;
            state.avatarUrl = action.payload.avatarUrl;
        },
        setAccount: (state, action) => {
            state.account = action.payload;
        },
        setPassword: (state, action) => {
            state.password = action.payload;
        },
        setVerificationCode: (state, action) => {
            state.verificationCode = action.payload;
        },
    }
})

// Action creators are generated for each case reducer function
export const { setFlushToken, setAccessToken, setUserInfo, setSelectInfo, setAccount, setPassword, setVerificationCode } = userSlice.actions

export default userSlice.reducer